         page 58,132
; This subroutine is a gate for calls from the rexx interpreter to function
; packages.
; This version is coded for microsoft c 3.0, small, medium, or large model
; It sets up segment registers, etc. for c language function handler,
;  calls the function handler, then returns to personal rexx
; It is called from rexx as a far procedure.
; For small model, environment block field env_exec_cseg should be 0,
;  and a near call to function handler will be issued
; For medium and large models, far call is used
; For all models, 4 byte address of call_block passed from rexx is
;  put on stack as argument to function handler

        include rexxcall.mac ; define an environment block

         public _rexxfcn
        .MODEL SMALL
         .CODE
_rexxfcn proc far

; at this point we are using the caller's stack
; but our code and data seg registers are already set up.
         push  bp             ; save callers frame pointer

; on entry, the following registers are of interest:
;        es:bx = pointer to a call block
;        es:si = pointer to environment block

; first, switch to our own stack

         mov   di,ss          ; so we can save callers stack regs
         mov   bp,sp          ; ...
         cli                  ; disable interrupts
         mov   ss,es:[si].env_sseg ; get stack seg
         mov   sp,es:[si].env_sp   ; set stack pointer
         sti                  ; allow interrupts
         push  bp             ; save callers sp
         push  di             ; save callers ss
         mov   bp,sp          ; remember position in stack

; ready to call command executor

         push  es             ; segment of call block
         push  bx             ; offset of call block
         cmp   word ptr es:[si].env_exec_addr+2,0
         je    near_call      ; use near call if command handler segment is 0
         call  dword ptr es:[si].env_exec_addr ; far call to command handler
         jmp   chop
near_call:
         call  word ptr es:[si].env_exec_addr  ; near call to command handler
chop:
         mov   sp,bp          ; chop stack

; return, with ax containing a return code
; restore the caller's stack

         pop   di             ; caller's ss
         pop   si             ; caller's sp
         cli                  ; prevent interrupts
         mov   ss,di          ; restore ss
         mov   sp,si          ; restore sp
         sti                  ; allow interrupts
         pop   bp             ; restore frame pointer
         ret                  ; return

_rexxfcn  endp

_text   ends
        end
